diff --git a/src/load_layout.c b/src/load_layout.c
index dc84c607f..4015be506 100644
--- a/src/load_layout.c
+++ b/src/load_layout.c
@@ -151,6 +151,19 @@ static int json_end_map(void *ctx) {
         json_node = json_node->parent;
     }
 
+    if (parsing_swallows) {
+        if (current_swallow->class == NULL &&
+            current_swallow->instance == NULL &&
+            current_swallow->window_role == NULL &&
+            current_swallow->title == NULL) {
+
+            /* We parsed an empty swallow definition. This is an invalid layout
+             * definition, hence we reject it. */
+            ELOG("Layout file is invalid: found an empty swallow definition.\n");
+            return 0;
+        }
+    }
+
     parsing_rect = false;
     parsing_deco_rect = false;
     parsing_window_rect = false;
